<? /*

taCs.php - 'the acronym CAPTCHA sucks' - by pete higgins (dante@inpdx.net) 2004,2005
a random scalable CAPTCHA image generator, version 0.1.3

changelog:

* 0.1.3 - added basic encryption/decryption functions
    - works now, practically ...
    - code cleanup

* 0.1.2 - defined configurable paths, and C_CHARSTARTX
    - made function tacs_genimage()
    - and tacs_genkey()
    - and tacs_showimage()

* 0.1.1 - added more useful comments

(paths are no longer hard-coded for testing purposed)

*/

// [ CONFIG ]
//
// paths:
define('C_ROOTPATH','/home/dante/www/neanderthalbastards.com/images/captcha');
define('C_CHARPATH',C_ROOTPATH.'/chars');    // path for source character images (*.png)
define('C_BGPATH',C_ROOTPATH.'/bgs');     // background image source path
define('C_SAVEPATH',C_ROOTPATH.'/saved'); // where to save images (if defined(SAVE_FILE))
// image settings
define('C_WIDTH',225);    // output width
define('C_HEIGHT',75);     // output height
define('C_CHARS',6);        // number of chars to use
define('C_CHARSTARTX',15);     // x position of first letter
define('C_SPACING',35);     // letter spacing
define('C_BORDER',true);    // border the image?
define('C_GRID',true);        // use a grid overlay?
if (C_GRID) {
  define('GRID_SPACE_ADJ',rand(3,17)); // spacing increment
  define('GRID_SPACEX',7);           // x spacing for grid
  define('GRID_SPACEY',7);         // y spacing for grid
  }
define('MIN_TRANS',45);            // minimun alpha for chars
define('MAX_TRANS',65);         // max alpha for chars

// encryption stuff:
define('TACSCODEKEY','a string a string a wonderful string');  // encryption codekey
/*
    == this is important! ==

    since the keys generated are INTENDED to be temporary
    you should chage this TACSCODEKEY constant *SOMEHOW*
    on a semi-regular basis. depending on your site's
    popularity, you may want to change it daily, or even
    hourly ... it's up to you. but if you DON'T change
    the default "string a wonderful string" codekey,
    *ANYONE* with half a wits about them can circumvent
    your CAPTCHA.

*/
// random debugging defines:
define('SAVE_FILE',false);         // debugging, save output files?
define('CHEAT',false); // for debugging, shows plaintext letters too

// end config type stuff

/* *** [ taCs functions: ] ********* */

function tacs_genkey() {

if (!$chars = getcatchars()) dir;

$str='';
for ($i=0; $i<C_CHARS-1; $i++) {
                $l = rand(0,sizeof($chars)-1);
                $str .= $l.":";
}
$l = rand(0,sizeof($chars)-1);
$str .= $l;
return tacs_encrypt($str);
}

function tacs_keystring($key) {

$key = tacs_decrypt($key);
$chars = getcatchars();

$keys = explode(":",$key);
$str='';
foreach ($keys as $key) {
    $str .= $chars[$key]{0};
}

return $str;

}

function tacs_genimage($key) {

    $backgrounds = array("bg-1_2.png","bg-1_3.png");

    // GD 2.0 making some images WIDTH x HEIGHT
    //   and set some color allocations
    //
    $im = imagecreatetruecolor(C_WIDTH,C_HEIGHT);
    $bo = imagecolorallocate($im,0,0,0);
    $bg = imagecolorallocate($im,255,255,255);
    $li = imagecolorallocate($im,50,50,50);

    // if bordering, do it, otherwise just fill the bg
    if (C_BORDER) {
        imagefilledrectangle($im,0,0,C_WIDTH,C_HEIGHT,$bo);
        imagefilledrectangle($im,1,1,C_WIDTH-2,C_HEIGHT-2,$bg);
    } else {
        imagefilledrectangle($im,0,0,C_WIDTH,C_HEIGHT,$bg);
    }

    // background images
    // [ load from C_BGPATH into $backgrounds ... TODO ]
    foreach ($backgrounds as $bgi) {
        // open each, copy to new image resized
        $tmpImg = imagecreatefrompng(C_BGPATH.'/'.$bgi);
        imagecopyresized($im,$tmpImg,0,0,0,0,C_WIDTH,C_HEIGHT,imagesx($tmpImg),imagesy($tmpImg));     
        // don't forget to free the memory.
        imagedestroy($tmpImg);
    }

    // the captcha letters
    //
    $nx = C_CHARSTART; $str='';

    if (!$chars = getcatchars()) { die; }
    $key = explode(":",decrypt($key));

    // each char
    for ($i=0; $i<sizeof($key); $i++) {
        // load the char image
        $tmpImg = imagecreatefrompng(C_CHARPATH.'/'.$chars[$key[$i]]);
        // randomly place this char vertically
        $ny = rand(3,25);
        // then copy to im, goto next x position, and free the memory.
        imagecopymerge($im,$tmpImg, $nx,$ny, 0,0, imagesx($tmpImg), imagesy($tmpImg), rand(MIN_TRANS,MAX_TRANS));
        $nx += C_SPACING;
        imagedestroy($tmpImg);
    }

    if (C_GRID) {  /* grid overlay */
        // not yet
        $x=GRID_SPACEX;
        $y=GRID_SPACEY;
        // make a new 'grid' image
        $imgr = imagecreatetruecolor(C_WIDTH,C_HEIGHT);
        $bo = imagecolorallocate($imgr,0,0,0);
        $bg = imagecolorallocate($imgr,255,255,255);
        imagefilledrectangle($imgr,0,0,C_WIDTH,C_HEIGHT,$bg);

        // place a line until the edge of file
        while ($x <= C_WIDTH) {
                   imageline($imgr, $x, 0, $x, C_HEIGHT, $bo);
            $x+=GRID_SPACEX+GRID_SPACE_ADJ;
             }
        // again
        while ($y <= C_HEIGHT) {
            imageline($imgr, 0, $y, C_WIDTH,$y, $bo);
            $y+=GRID_SPACEY+GRID_SPACE_ADJ;
        }    

        // copy 'grid' image on top of the captcha image
        imagecopymerge($im,$imgr, 0,0, 0,0,imagesx($imgr),imagesy($imgr),15);
        // free the memory (it's important, really)
        imagedestroy($imgr);
    }

    return $im;

} // end function tacs_genimage()

function tacs_showimage($img) {

    header("Content-type: image/png ");
    imagepng($img);
    imagedestroy($img);

}

function getcatchars() {

$path = C_CHARPATH;

if (is_dir($path)) {
if($handle = opendir($path)){
  while(false !== ($file = readdir($handle))){
    // only .png files, and hidden files. needs be case-insensative tho
    if(!preg_match("/^\./", $file) && preg_match("/.*\.png/",$file)){
      if(is_dir($path."/".$file)){
      $dirs[] = $file;
      }else{ $files[] = $file;
      }
    }
  }
closedir($handle);
}

}

if (isset($files) && is_array($files)) {
return $files;
} else {
return 0;
}

}

function tacs_encrypt($txt,$altkey='') {
    srand((double)microtime()*342345);
    $encrypt_key = md5(rand(0,32000));
    $ctr = 0;
    $tmp = "";
    for ($i = 0;$i<strlen($txt);$i++) {
        if ($ctr == strlen($encrypt_key)) $ctr=0;
        $tmp.= substr($encrypt_key,$ctr,1) .
              (substr($txt,$i,1) ^ substr($encrypt_key,$ctr,1));
        $ctr++;
        }
    return (base64_encode(tacs_keyED($tmp,$altkey)));
    }

function tacs_decrypt($txt,$altkey='') {
    $txt = empty($altkey) ? tacs_keyED(base64_decode($txt)) : tacs_keyED(base64_decode($txt),$altkey);
    $tmp = "";
    for ($i = 0;$i<strlen($txt);$i++) {
        $md5 = substr($txt,$i,1);
        $i++;
        $tmp.= (substr($txt,$i,1) ^ $md5);
        }
    return $tmp;
    }

function tacs_keyED($txt,$altkey='') {
    $encrypt_key = empty($altkey) ? md5(TACSCODEKEY) : md5($altkey);
    $ctr = 0;
    $tmp = "";
    for ($i = 0;$i<strlen($txt);$i++) {
        if ($ctr == strlen($encrypt_key)) $ctr = 0;
        $tmp.= substr($txt,$i,1) ^ substr($encrypt_key,$ctr,1);
        $ctr++;
        }
   return $tmp;
   }


?>
