package org.penguindreams.bmcb.analyzers;

import java.awt.Image;

import org.apache.log4j.Logger;
import org.penguindreams.bmcb.util.ApplicationLogger;


public abstract class AbstractAnalyzer {
	
	protected Logger log;
	
	public AbstractAnalyzer() {
		log = ApplicationLogger.getLogger(this.getClass());
	}
	
	public abstract void trainUsingSegments(Image[] segments, char[] answer)  throws AnalysisNotSupportedException;
	
	public abstract void trainUsingImage(Image img, char[]answer)  throws AnalysisNotSupportedException;
	
	public abstract char[] analyzeSegments(Image[] segments) throws AnalysisNotSupportedException;
	
	public abstract char[] analyzeImage(Image inputImage) throws AnalysisNotSupportedException;
		
}
