/*
 * AnalysisNotSupportedException.java 
 *  BMCB
 *  Sumit Khanna / http://penguindreams.org
 */
package org.penguindreams.bmcb.analyzers;



@SuppressWarnings("serial")
public class AnalysisNotSupportedException extends Exception {
	
	/**
	 * Thrown when an invalid analysis constructor is used.
	 * Analyzers can either take in an entire image or a set of segmented images.
	 * If an analyzer only supports one of these options, the alternative constructor
	 * will throw this exception.
	 * @param s exception message
	 */
	public AnalysisNotSupportedException(String s) {
		super(s);
	}
}
