package org.penguindreams.bmcb.data;

public class ExperimentResult {

	private int charsCorrect, charsIncorrect, wordsCorrect, wordsIncorrect;
	
	private String anName, desc, setName;
	
	public ExperimentResult(String setName, String anName, String desc) {
		this.anName = anName;
		this.setName = setName;
		this.desc = desc;
		charsCorrect = 0;
		charsIncorrect = 0;
		wordsCorrect = 0;
		wordsIncorrect = 0;
	}
	
	public String getAnalyzerName() { return anName; }
	public String getSetName() { return setName; }
	public String getDescription() { return desc; }
	
	/*
	public void addCharsCorrect(int i) { charsCorrect += i;}
	public void addCharsIncorrect(int i) { charsIncorrect += i; }
	public void addWordsCorrect(int i) { wordsCorrect += i;}
	public void addWordsIncorrect(int i) { wordsIncorrect += i; }*/
	
	public float getCharacterAccuracy() { return ((float)charsCorrect / (float)(charsIncorrect + charsCorrect)); }
	public float getWordAccuracy() { return ((float)wordsCorrect / (float)(wordsIncorrect + wordsCorrect)); }
	
	public String toString() {
		String retval = "";
		
		retval += "\nSet:\t" + setName + "\n";
		retval += "\nAnalyzer:\t" + anName + "\n";
		retval += "Description:\t" + desc + "\n\n";
		
		retval += "Correct Characters:\t" + charsCorrect + "\n";
		retval += "Incorrect Characters:\t" + charsIncorrect + "\n";
		retval += "Accuracy:\t" +  getCharacterAccuracy()  + "\n\n";
		
		retval += "Correct Words:\t" + wordsCorrect + "\n";
		retval += "Incorrect Words:\t" + wordsIncorrect + "\n";
		retval += "Accuracy:\t" +  getWordAccuracy()  +"\n\n";		

		
		return retval;
	}
	
	
	public void addResult(char[] expected, char[] results) {	
		
		boolean wordCorrect = true;
		for(int i=0; i < results.length; i++) {
			if(expected.length >= i+1 && 
					Character.toLowerCase(expected[i]) == Character.toLowerCase(results[i])) {
				charsCorrect++;
			}
			else {
				charsIncorrect++;
				wordCorrect = false;
			}
		}
		//add remaining
		charsIncorrect += Math.abs(expected.length - results.length);
		
		//entire word
		if(wordCorrect && expected.length == results.length) {
			wordsCorrect++;
		}
		else {
			wordsIncorrect++;
		}
		
	}
	
	
}
