package org.penguindreams.bmcb.generators;

import java.io.File;
import java.io.IOException;

import org.penguindreams.bmcb.data.DataSet;
import org.penguindreams.bmcb.generators.AbstractGenerator;
import org.penguindreams.bmcb.util.ImageLoader;

public class CommandLineGenerator extends AbstractGenerator {
	
	private String cmd;

	public CommandLineGenerator(DataSet data, String cmd,File outdir ) {
		super(data, outdir);
		this.cmd = cmd;
	}
	
	public void generateSet() throws GenerationException {
		//deletes contents of directory
		super.generateSet();
		
		log.info("Using " + cmd + " to generate set to " + outdir);
		long starttime = System.currentTimeMillis();
		for(int i=0; i < data.getSize(); i++) {
			try {
				String[] r = {cmd, data.get(i) , new File(outdir,data.get(i)+"." + ImageLoader.IMG_EXTENTION).toString() };
				log.trace("Running \"" + r[0] + " " + r[1] + " " + r[2]);
				Process p = Runtime.getRuntime().exec(r);
				p.waitFor();
				log.trace("Successfully Wrote " + r[1]);
			} catch (IOException e) {
				log.error("I/O Error When Executing " + cmd);
				e.printStackTrace();
			} catch (InterruptedException e) {
				e.printStackTrace();
				log.error("Process Interrupted When Executing " + cmd);
			}
		}
		long total = System.currentTimeMillis() - starttime;
		log.info("Set Generated in " + total + "ms in folder "+ outdir);
	}
	
	


}
