package org.penguindreams.bmcb.segmentators;

import java.awt.image.BufferedImage;


public class EvenLengthSegmentator extends AbstractSegmentator {

	private int segments;
	
	public EvenLengthSegmentator(BufferedImage img, int segments) {
		super(img);
		this.segments = segments;
	}
	
	public EvenLengthSegmentator(BufferedImage img) {
		super(img);
		this.segments = 0;
	}

	@Override
	public int[] getSegmentAxes() {
		
		int gapLength = img.getWidth() / segments;
		int[] retval = new int[segments-1];
		for(int i=0; i<segments-1; i++) {
			retval[i] = gapLength * (i+1);			
		}
		return retval;
	}

	public int getSegments() {
		return segments;
	}

	public void setSegments(int segments) {
		this.segments = segments;
	}

}
