package org.penguindreams.bmcb.util;

/*
 * Log4j handler
 * 
 * Created on Aug 7, 2007
 * Sumit Khanna
 */

import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.util.Properties;

import org.apache.log4j.Logger;
import org.apache.log4j.PropertyConfigurator;


/**
 * @author s21574k
 */
public class ApplicationLogger {

	private static boolean loginit = false;
	
	public static void setLoggerConfig(String configfile) {
		Properties prop = new Properties();
		File logfile = new File(configfile);
		try {
			FileInputStream logstream = new FileInputStream(logfile);
			prop.load(logstream);
			logstream.close();
			loginit = true;
		}
		catch(IOException o) {
			System.err.println("Error: Could not load log4j property file");
			loginit = false; 
		}
		PropertyConfigurator.configure(prop);		
	}
	
	@SuppressWarnings("unchecked")
	public static Logger getLogger(Class subclass) {
		if(loginit == false) {
			System.err.println("Warning. No Logger Configured. Please run setLoggerConfig(configfile) first.");
		}
		
		return Logger.getLogger(subclass);
	}
	
	public static void writeArrayToDebug(Logger log, Object[] array) {
		String out = "{";
		for(Object o : array) {
			out += "\"" + o.toString() + "\",";
		}
		out += "}";
		log.debug(out);
	}

}

